; 
    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib

    include \masm32\macros\macros.asm

    include timers.asm
; 
    .data
    .code
; 
start: 
; 
    ;repeat 3          ; Used to check sensitivity to alignment
    ;  nop
    ;endm
    
    counter_begin 10000000, HIGH_PRIORITY_CLASS
    ; 1.
      PUSHFD
    ; ...
      POPFD
    counter_end
    print ustr$(eax)
    print chr$(" PUSHFD cycles",13,10)

    counter_begin 10000000, HIGH_PRIORITY_CLASS
    ; 2.
      PUSH EAX
      LAHF
    ; ...
      SAHF
      POP EAX ; avoid partial register stall by writing to the whole register
    counter_end
    print ustr$(eax)
    print chr$(" PUSH/LAHF cycles",13,10)

    mov   eax, input(13,10,"Press enter to exit...")
    exit
; 
end start
